# -*-coding:Utf-8 -*-
import es, ConfigParser, os, usermsg, popuplib, playerlib, random


infos = es.AddonInfo()
infos.name = 'CustomSetup'
infos.basename = 'CustomSetup'
infos.version = '1.1.3'
infos.author = 'Matth'
infos.date = '06-09-2010'

es.ServerVar((infos.basename), infos.version + " by " + infos.author).makepublic()

gamedir = str(es.ServerVar('eventscripts_gamedir')) + '/'
cfg = ConfigParser.ConfigParser()
cfg_dir = es.getAddonPath('CustomSetup') + '/configuration.cfg'
materials = 'materials/models/player/'
models = 'models/player/'

skindict = {}
popup_list = []

def load():
    if os.path.isfile(cfg_dir): cfg.read(cfg_dir)
    else:
        cfg.add_section('skin_section')
        cfg.set('skin_section', 'skin1', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.set('skin_section', 'skin2', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.set('skin_section', 'skin3', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.set('skin_section', 'skin4', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.set('skin_section', 'skin5', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.set('skin_section', 'skin6', '"dossier/[sous_dossier/][fichier.mdl]"')
        cfg.add_section('administrateur')
        cfg.set('administrateur', 'admin1', '"STEAM_0:0:15646786"')
        cfg.set('administrateur', 'admin2', '"STEAM_0:0:00000000"')
        cfg.add_section('vip')
        cfg.set('vip', 'vip1', '"STEAM_0:0:00000000"')
        cfg.set('vip', 'vip2', '"STEAM_0:0:00000000"')
        cfg.add_section('configuration')
        cfg.set('configuration', 'custom_command', '"!model"')
        cfg.set('configuration', 'custom_join_choose', '1')
        cfg.set('configuration', 'custom_skin_ct', '"skin1, skin2"')
        cfg.set('configuration', 'custom_skin_t', '"skin3, skin4"')
        cfg.set('configuration', 'custom_skin_vip_ct', '"skin5, skin6"')
        cfg.set('configuration', 'custom_skin_vip_t', '"skin,5, skin6"')
        cfg.set('configuration', 'custom_skin_bot', '1')
        lines = open(cfg_dir, 'w')
        ComWrite(lines)
    es.regclientcmd('!install', 'CustomSetup/InstallSkin', '!install le skin')
    es.addons.registerSayFilter(SayFilter)
    downloadable()

def ComWrite(file):
    cfg.write(file)
    file.write('#######################################################################################\n')
    file.write('#Pour rajouter d\'autres admins procedez de la maniere suivante (admin3, admin4, etc.):\n#        admin3 = "STEAM_0:0:000000"\n#        admin4 = "STEAM_0:0:000000"\n#\n')
    file.write('#Pour supprimer des admins, rajouter un "#" devant la ligne desiree:\n#        #admin3 = "STEAM_0:0:000000"\n#        #admin4 = "STEAM_0:0:000000"\n\n')
    file.write('#Pour rajouter d\'autres vip procedez de la maniere suivante (vip3, vip4, etc.):\n#        vip3 = "STEAM_0:0:000000"\n#        vip4 = "STEAM_0:0:000000"\n#\n')
    file.write('#Pour supprimer des vip, rajouter un "#" devant la ligne desiree:\n#        #vip3 = "STEAM_0:0:000000"\n#        #vip4 = "STEAM_0:0:000000"\n\n')
    file.write('#Pour rajouter d\'autres skins procedez de la maniere suivante (nom_du_skin = "a/a" etc.):\n#        kirby = "slow/kirby/"\n#        skin5 = "dossier/[sous_dossier/][fichier.mdl]"\n#\n')
    file.write('#Pour supprimer des skins, rajouter un "#" devant la ligne desiree:\n#        #kirby = "slow/kirby/"\n#        #skin5 = "dossier/[sous_dossier/][fichier.mdl]"\n\n')
    file.write('#Systeme de configuration:\n')
    file.write('#   custom_command:\n#          La commande utilisee pour ouvrir le menu de skin (defaut = "!model")\n#\n')
    file.write('#   custom_join_choose:\n#          Le menu s\'ouvrira lorsque le joueur rejoindra une equipe (1 = oui, 0 = non)\n#\n')
    file.write('#   custom_skin_bot:\n#          Attribue un skin aleatoire aux bots (1 = oui, 0 = non)\n#\n')
    file.write('#   custom_skin_ct:\n#          Les skins qui seront disponibles pour les ct,\n#          Mettre les skins entre guillemet seprares par une virgule ("skin1, skin2")\n#\n')
    file.write('#   custom_skin_t:\n#          Les skins qui seront disponibles pour les t,\n#          Mettre les skins entre guillemet seprares par une virgule ("skin1, skin2")\n#\n')
    file.write('#   custom_skin_vip_ct:\n#          Les skins qui seront reserves (ct) pour les joueurs dis VIP,\n#          Mettre les skins entre guillemet seprares par une virgule ("skin1, skin2")\n#\n')
    file.write('#   custom_skin_vip_t:\n#          Les skins qui seront reserves (t) pour les joueurs dis VIP,\n#          Mettre les skins entre guillemet seprares par une virgule ("skin1, skin2")\n#\n')
    file.close()

def downloadable():
    for skin in cfg.options('skin_section'):
        materials_skin = materials + cfg.get('skin_section', skin).strip('""') if not cfg.get('skin_section', skin).strip('""').endswith('.mdl') else materials + os.path.split(cfg.get('skin_section', skin).strip('""'))[0] + '/'
        models_skin = models + cfg.get('skin_section', skin).strip('""') if not cfg.get('skin_section', skin).strip('""').endswith('.mdl') else models + os.path.split(cfg.get('skin_section', skin).strip('""'))[0] + '/'
        try:
            for fichier in os.listdir(gamedir + materials_skin):
                if os.path.isfile(gamedir + materials_skin + fichier): es.stringtable('downloadables', materials_skin + fichier)
                else: AddSubdir(materials_skin, fichier + '/')
            for fichier in os.listdir(gamedir + models_skin):
                if os.path.isfile(gamedir + models_skin + fichier): es.stringtable('downloadables', models_skin + fichier)
                else: AddSubdir(models_skin, fichier + '/')
        except OSError: es.dbgmsg(0, 'Skin: %s introuvable, le script ne fonctionnera pas correctement' % skin)

def AddSubdir(directory, subdir):
    for fichier in os.listdir(gamedir + directory + subdir):
        if os.path.isfile(gamedir + directory + subdir + fichier): es.stringtable('downloadables', directory + subdir + fichier)
        else: AddSubdir(directory + subdir, fichier + '/')

def SayFilter(userid, text, teamonly):
    if not text.lower().strip('""') == cfg.get('configuration', 'custom_command').strip('""'):
        return (userid, text, teamonly)
    CreatePopup(userid)
    return (0, 0, 0)

def CreatePopup(userid):
    name = 'menu_model_%s' % userid
    if not name in popup_list: popup_list.append(name)
    popupmodel = popuplib.easymenu(name, None, ChoicePopup)
    popupmodel.settitle('Custom Setup')
    team = es.getplayerteam(userid)
    if team == 3:
        custom_skin_ct = cfg.get('configuration', 'custom_skin_ct').replace(' ','').strip('""').split(',')
        custom_skin_vip_ct = cfg.get('configuration', 'custom_skin_vip_ct').replace(' ','').strip('""').split(',')
        if custom_skin_ct != ['']:
            for skin in custom_skin_ct:
                popupmodel.addoption(cfg.get('skin_section', skin).strip('""'), skin)
        if custom_skin_vip_ct != ['']:
            for vip in cfg.options('vip'):
                if es.getplayersteamid(userid) != cfg.get('vip', vip).strip('""'):
                    continue
                for skin in custom_skin_vip_ct:
                    popupmodel.addoption(cfg.get('skin_section', skin).strip('""'), skin)
    elif team == 2:
        custom_skin_t = cfg.get('configuration', 'custom_skin_t').replace(' ','').strip('""').split(',')
        custom_skin_vip_t = cfg.get('configuration', 'custom_skin_vip_t').replace(' ','').strip('""').split(',')
        if custom_skin_t != ['']:
            for skin in custom_skin_t:
                popupmodel.addoption(cfg.get('skin_section', skin).strip('""'), skin)
        if custom_skin_vip_t != ['']:
            for vip in cfg.options('vip'):
                if es.getplayersteamid(userid) != cfg.get('vip', vip).strip('""'):
                    continue
                for skin in custom_skin_vip_t:
                    popupmodel.addoption(cfg.get('skin_section', skin).strip('""'), skin)
    popupmodel.send(userid)

def ChoicePopup(userid, choice, popupname):
    player = playerlib.getPlayer(userid)
    if player.isdead:
        if choice != 'admin':
            if not skindict.has_key(userid):
                skindict[userid] = choice
            else:
                skindict[userid] = choice
    else:
        if choice != 'admin':
            if not skindict.has_key(userid):
                skindict[userid] = choice
            else:
                skindict[userid] = choice
            SetModel(player, choice, userid)

def SetModel(player, skin, userid):
    if not skin.endswith('.mdl'):
        for mdl in os.listdir(gamedir + models + skin):
            if os.path.splitext(mdl)[1] == '.mdl':
                player.model = models + skin + mdl
    else:
        player.model = models + skin

def InstallSkin():
    userid = es.getcmduserid()
    if es.getargc() != 3:
        return usermsg.echo(userid, 'Mauvaise syntaxe:\nSyntaxe = !install skin dossier/sous_dossier/\nSyntaxe = !install admin "STEAM_0:0:1234567"\nExemple = !install skin pink_panther/skin_panther/')
    for admin in cfg.options('administrateur'):
        if es.getplayersteamid(userid) != cfg.get('administrateur', admin).strip('""'):
            continue
        args = es.getargv(2)
        if es.getargv(1) == 'skin':
            if not os.path.isdir(materials + args): return usermsg.echo(userid, 'dossier inexistant: %s' % args)
            cfg.set('skin_section', 'skin_' + args[0:4], '"%s/"' % args)
        elif es.getargv(1) == 'admin':
            cfg.set('administrateur', 'Admin' + args[10:14], '"%s"' % args)
        elif es.getargv(1) == 'vip':
            cfg.set('vip', 'vip' + args[10:14], '"%s"' % args)
        else: return usermsg.echo(userid, 'Mauvaise syntaxe:\nSyntaxe = !install skin dossier/sous_dossier/\nSyntaxe = !install admin "STEAM_0:0:1234567"\nExemple = !install skin pink_panther/skin_panther/')
        file = open(cfg_dir, 'w')
        ComWrite(file)
        break
    else: usermsg.echo(userid, 'vous n\'êtes pas admin !')

def player_spawn(event_var):
    userid = int(event_var['userid'])
    player = playerlib.getPlayer(userid)
    if userid in skindict:
        skin = skindict[userid]
        return SetModel(player, skin, userid)
    elif cfg.getint('configuration', 'custom_skin_bot'):
        if es.isbot(userid):
            if player.team == 3:
                custom_skin_ct = cfg.get('configuration', 'custom_skin_ct').replace(' ','').strip('""').split(',')
                if not custom_skin_ct == ['']:
                    skin_random = random.choice(custom_skin_ct)
                    skin = cfg.get('skin_section', skin_random).strip('""')
                    return SetModel(player, skin, userid)
            elif player.team == 2:
                custom_skin_t = cfg.get('configuration', 'custom_skin_t').replace(' ','').strip('""').split(',')
                if not custom_skin_t == ['']:
                    skin_random = random.choice(custom_skin_t)
                    skin = cfg.get('skin_section', skin_random).strip('""')
                    return SetModel(player, skin, userid)

def player_team(event_var):
    userid = int(event_var['userid'])
    if userid in skindict:
        del(skindict[userid])
    if cfg.getint('configuration', 'custom_join_choose'):CreatePopup(userid)
        
def unload():
    for popup in popup_list: popuplib.delete(popup)
    es.unregclientcmd('!install')
    es.addons.unregisterSayFilter(SayFilter)

def es_map_start(event_var):
    cfg.read(cfg_dir)
    downloadable()
    for userid in skindict: del(skindict[userid])
    for popup in popup_list: popuplib.delete(popup)

def player_disconnect(event_var):
    userid = int(event_var['userid'])
    if userid in skindict:
        del(skindict[userid])
        

    


        
                                                                                                         
        
        
    


